# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mrpt_msgs/Waypoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class Waypoint(genpy.Message):
  _md5sum = "887461b3b9de175eaacf925a0b919b18"
  _type = "mrpt_msgs/Waypoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Pose target  # target pose in map frame. Heading may be ignored
bool ignore_heading
bool allow_skip
float64 allowed_distance   # minimum distance (meters) to consider the target reached
# [0,1] relative speed at this target. 0=means use slow down
# so the robot approaches the goal slowly:
float64 speed_ratio
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['target','ignore_heading','allow_skip','allowed_distance','speed_ratio']
  _slot_types = ['geometry_msgs/Pose','bool','bool','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       target,ignore_heading,allow_skip,allowed_distance,speed_ratio

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Waypoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.target is None:
        self.target = geometry_msgs.msg.Pose()
      if self.ignore_heading is None:
        self.ignore_heading = False
      if self.allow_skip is None:
        self.allow_skip = False
      if self.allowed_distance is None:
        self.allowed_distance = 0.
      if self.speed_ratio is None:
        self.speed_ratio = 0.
    else:
      self.target = geometry_msgs.msg.Pose()
      self.ignore_heading = False
      self.allow_skip = False
      self.allowed_distance = 0.
      self.speed_ratio = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_7d2B2d().pack(_x.target.position.x, _x.target.position.y, _x.target.position.z, _x.target.orientation.x, _x.target.orientation.y, _x.target.orientation.z, _x.target.orientation.w, _x.ignore_heading, _x.allow_skip, _x.allowed_distance, _x.speed_ratio))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target is None:
        self.target = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 74
      (_x.target.position.x, _x.target.position.y, _x.target.position.z, _x.target.orientation.x, _x.target.orientation.y, _x.target.orientation.z, _x.target.orientation.w, _x.ignore_heading, _x.allow_skip, _x.allowed_distance, _x.speed_ratio,) = _get_struct_7d2B2d().unpack(str[start:end])
      self.ignore_heading = bool(self.ignore_heading)
      self.allow_skip = bool(self.allow_skip)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_7d2B2d().pack(_x.target.position.x, _x.target.position.y, _x.target.position.z, _x.target.orientation.x, _x.target.orientation.y, _x.target.orientation.z, _x.target.orientation.w, _x.ignore_heading, _x.allow_skip, _x.allowed_distance, _x.speed_ratio))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target is None:
        self.target = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 74
      (_x.target.position.x, _x.target.position.y, _x.target.position.z, _x.target.orientation.x, _x.target.orientation.y, _x.target.orientation.z, _x.target.orientation.w, _x.ignore_heading, _x.allow_skip, _x.allowed_distance, _x.speed_ratio,) = _get_struct_7d2B2d().unpack(str[start:end])
      self.ignore_heading = bool(self.ignore_heading)
      self.allow_skip = bool(self.allow_skip)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7d2B2d = None
def _get_struct_7d2B2d():
    global _struct_7d2B2d
    if _struct_7d2B2d is None:
        _struct_7d2B2d = struct.Struct("<7d2B2d")
    return _struct_7d2B2d
