// Auto-generated. Do not edit!

// (in-package mrpt_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class Waypoint {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.target = null;
      this.ignore_heading = null;
      this.allow_skip = null;
      this.allowed_distance = null;
      this.speed_ratio = null;
    }
    else {
      if (initObj.hasOwnProperty('target')) {
        this.target = initObj.target
      }
      else {
        this.target = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('ignore_heading')) {
        this.ignore_heading = initObj.ignore_heading
      }
      else {
        this.ignore_heading = false;
      }
      if (initObj.hasOwnProperty('allow_skip')) {
        this.allow_skip = initObj.allow_skip
      }
      else {
        this.allow_skip = false;
      }
      if (initObj.hasOwnProperty('allowed_distance')) {
        this.allowed_distance = initObj.allowed_distance
      }
      else {
        this.allowed_distance = 0.0;
      }
      if (initObj.hasOwnProperty('speed_ratio')) {
        this.speed_ratio = initObj.speed_ratio
      }
      else {
        this.speed_ratio = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Waypoint
    // Serialize message field [target]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.target, buffer, bufferOffset);
    // Serialize message field [ignore_heading]
    bufferOffset = _serializer.bool(obj.ignore_heading, buffer, bufferOffset);
    // Serialize message field [allow_skip]
    bufferOffset = _serializer.bool(obj.allow_skip, buffer, bufferOffset);
    // Serialize message field [allowed_distance]
    bufferOffset = _serializer.float64(obj.allowed_distance, buffer, bufferOffset);
    // Serialize message field [speed_ratio]
    bufferOffset = _serializer.float64(obj.speed_ratio, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Waypoint
    let len;
    let data = new Waypoint(null);
    // Deserialize message field [target]
    data.target = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [ignore_heading]
    data.ignore_heading = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [allow_skip]
    data.allow_skip = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [allowed_distance]
    data.allowed_distance = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [speed_ratio]
    data.speed_ratio = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 74;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mrpt_msgs/Waypoint';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '887461b3b9de175eaacf925a0b919b18';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    geometry_msgs/Pose target  # target pose in map frame. Heading may be ignored
    bool ignore_heading
    bool allow_skip
    float64 allowed_distance   # minimum distance (meters) to consider the target reached
    # [0,1] relative speed at this target. 0=means use slow down
    # so the robot approaches the goal slowly:
    float64 speed_ratio
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Waypoint(null);
    if (msg.target !== undefined) {
      resolved.target = geometry_msgs.msg.Pose.Resolve(msg.target)
    }
    else {
      resolved.target = new geometry_msgs.msg.Pose()
    }

    if (msg.ignore_heading !== undefined) {
      resolved.ignore_heading = msg.ignore_heading;
    }
    else {
      resolved.ignore_heading = false
    }

    if (msg.allow_skip !== undefined) {
      resolved.allow_skip = msg.allow_skip;
    }
    else {
      resolved.allow_skip = false
    }

    if (msg.allowed_distance !== undefined) {
      resolved.allowed_distance = msg.allowed_distance;
    }
    else {
      resolved.allowed_distance = 0.0
    }

    if (msg.speed_ratio !== undefined) {
      resolved.speed_ratio = msg.speed_ratio;
    }
    else {
      resolved.speed_ratio = 0.0
    }

    return resolved;
    }
};

module.exports = Waypoint;
